﻿
namespace VirtualCollectionTest.Web
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;

    public class TestClass
    {
        private Guid _guid;
        [Key]
        public Guid Guid
        {
            get { return _guid; }
            set { _guid = value; }
        }
        public string Name { get; set; }
        public int Age { get; set; }

        public TestClass()
        {
            Guid = Guid.NewGuid();
        }
    }

    [EnableClientAccess()]
    public class DomainService1 : DomainService
    {
        public IQueryable<TestClass> GetTestClass(int startIndex, int itemsCount)
        {
            var query = TestCollection.OrderBy(t => t.Guid).AsQueryable();

            query = query.Skip(startIndex).Take(itemsCount);

            return query;
        }

        private List<TestClass> _testCollection = new List<TestClass>
                                                                      {
                                                                          new TestClass{Name = "123", Age=15},
                                                                          new TestClass{Name = "456", Age=15},
                                                                          new TestClass{Name = "789", Age=15},
                                                                          new TestClass{Name = "123", Age=15}
                                                                      };
        public List<TestClass> TestCollection
        {
            get { return _testCollection; }
            set
            {
                _testCollection = value;
            }
        }
    }
}


